﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Silanis.ESL.SDK;
using Silanis.ESL.SDK.Builder;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Diagnostics;
using System.IO;
using Newtonsoft.Json.Linq;


namespace PackageStatusToDraft
{
    class ChangePackageStatusToDraft
    {
        private static string key = "WlFJOGs2ZmFWb004OldKV2ZSckh3dWZBVw==";
        private static string url = "https://sandbox.esignlive.com/api";

        public static void Main(string[] args)
        {

            string jsonString = "{\"documents\":[{\"approvals\":[{\"id\":\"ExampleSignatureId\",\"role\":\"Signer1\",\"fields\":[{\"page\":0,\"top\":100,\"subtype\":\"FULLNAME\",\"height\":50,\"left\":100,\"width\":200,\"type\":\"SIGNATURE\",\"name\":\"ExampleSignatureId\"}],\"name\":\"\"}],\"id\":\"sample-contract\",\"name\":\"First Document\"}],\"status\":\"SENT\",\"description\":\"This is a package created using the eSignLive REST API\",\"type\":\"PACKAGE\",\"roles\":[{\"id\":\"Signer1\",\"type\":\"SIGNER\",\"signers\":[{\"email\":\"john.smith@mailinator.com\",\"firstName\":\"John\",\"lastName\":\"Smith\",\"id\":\"Signer1\"}],\"name\":\"Signer1\"}],\"name\":\"ChangePackageStatusExample REST API\"}";

            StringContent jsonContent = new StringContent(jsonString, Encoding.UTF8, "application/json");

            byte[] fileByteArray = File.ReadAllBytes(@"C:/Users/hhaidary/Desktop/pdf/doc1.pdf");
            ByteArrayContent content = new ByteArrayContent(fileByteArray);

            content.Headers.ContentDisposition = new ContentDispositionHeaderValue("form-data");
            content.Headers.ContentDisposition.Name = "\"file\"";
            content.Headers.ContentDisposition.FileName = "\"doc1.pdf\"";
            content.Headers.ContentType = new MediaTypeHeaderValue("application/pdf");

            MultipartFormDataContent form = new MultipartFormDataContent();
            form.Add(content, "\"file\"", "\"doc1.pdf\"");
            form.Add(jsonContent, "\"payload\"");

            HttpClient myClient = new HttpClient();
            myClient.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Basic", key);
            myClient.DefaultRequestHeaders.Add("Accept", "application/json");

            var response = myClient.PostAsync(new Uri(url) + "/packages/", form).Result;
            JObject jsonResponse = JObject.Parse(response.Content.ReadAsStringAsync().Result);
            Debug.WriteLine(jsonResponse.ToString());

            //Change Package Status To Draft
            string jsonString2 = "{\"status\" : \"DRAFT\"}";
            StringContent jsonContent2 = new StringContent(jsonString2, Encoding.UTF8, "application/json");

            response = myClient.PutAsync(new Uri(url) + "/packages/" + jsonResponse["id"], jsonContent2).Result;
        }
    }
}
